/*
 * Copyright 1998-2001, University of Notre Dame.
 * Authors: Jeffrey M. Squyres, Arun Rodrigues, and Brian Barrett with
 *          Kinis L. Meyer, M. D. McNally, and Andrew Lumsdaine
 * 
 * This file is part of the Notre Dame LAM implementation of MPI.
 * 
 * You should have received a copy of the License Agreement for the Notre
 * Dame LAM implementation of MPI along with the software; see the file
 * LICENSE.  If not, contact Office of Research, University of Notre
 * Dame, Notre Dame, IN 46556.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted subject to the conditions specified in the
 * LICENSE file.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * 
 * Additional copyrights may follow.
 * 
 *	Ohio Trollius
 *	Copyright 1995 The Ohio State University
 *	GDB
 *
 *	$Id: boot.h,v 1.4 2001/02/12 21:17:12 jsquyres Exp $
 * 
 *	Function:	- constants associated with booting
 */

#ifndef _BOOT
#define _BOOT

#include <stdio.h>

#include <lamnet.h>
#include <all_list.h>


/*
 * default configuration files
 */
#define DEFFCONFIGH	"lam-conf.otb"

/*
 * default tools
 */
#define DEFTRESETH	"tkill"

/*
 * share/boot/inetexec.c
 */
int inetexec(char *host, char *username, char **argv, char *prefix,
	     int fl_fast);

/*
 * share/boot/bhostparse.c 
 */
int bhostparse(FILE *fp, struct lamnode **plamnet, int *pnlamnet);

/*
 * share/boot/lambootagent.c
 */
int lambootagent(struct lamnode *lamnet, int nlamnet, int *nboot, int *nrun);

/*
 * share/boot/psc_parse.c
 */
int psc_parse(FILE *fp, LIST **list_psc, char **argv_var);

#endif
