// $Id: dup_test.cc,v 1.1.1.1.2.1 2001/10/29 04:32:56 bbarrett Exp $
//
// Copyright 1997-2001, University of Notre Dame.
// Authors: Jeffrey M. Squyres, Jeremy G. Siek, Michael P. McNally, and
//          Andrew Lumsdaine
// 
// This file is part of the Notre Dame C++ bindings for MPI.
// 
// You should have received a copy of the License Agreement for the Notre
// Dame C++ bindings for MPI along with the software; see the file
// LICENSE.  If not, contact Office of Research, University of Notre
// Dame, Notre Dame, IN 46556.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted subject to the conditions specified in the
// LICENSE file.
// 
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
// IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// 
// Additional copyrights may follow.
//

#include "mpi2c++_test.h"

void
dup_test()
{
  char msg[150];
  int duprank;
  int dupsize;
  MPI::Intracomm dupcomm;

  dupcomm = MPI::COMM_NULL;

  Testing("Dup");

  dupcomm = MPI::COMM_WORLD.Dup();
    
  duprank = dupcomm.Get_rank();
  if(duprank != my_rank) {
    sprintf(msg, "NODE %d - 1) ERROR in Intracomm.Dip(), rank = %d, should be %d", my_rank, duprank, my_rank);
    Fail(msg);
  }

  dupsize = dupcomm.Get_size();
  if(dupsize != comm_size) {
    sprintf(msg, "NODE %d - 1) ERROR in Intracomm.Dip(), size = %d, should be %d", comm_size, dupsize, comm_size);
    Fail(msg);
  }

  Pass(); // Dup

  if (dupcomm != MPI::COMM_NULL)
    dupcomm.Free();
}


