// $Id: rank_size.cc,v 1.1.1.1.2.1 2001/10/29 04:32:58 bbarrett Exp $
//
// Copyright 1997-2001, University of Notre Dame.
// Authors: Jeffrey M. Squyres, Jeremy G. Siek, Michael P. McNally, and
//          Andrew Lumsdaine
// 
// This file is part of the Notre Dame C++ bindings for MPI.
// 
// You should have received a copy of the License Agreement for the Notre
// Dame C++ bindings for MPI along with the software; see the file
// LICENSE.  If not, contact Office of Research, University of Notre
// Dame, Notre Dame, IN 46556.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted subject to the conditions specified in the
// LICENSE file.
// 
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
// IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
// 
// Additional copyrights may follow.
//

#include "mpi2c++_test.h"

void
rank_size()
{
  char msg[150];
  int rank;
  int size;

  Testing("Get_rank");

  MPI_Comm_rank(MPI_COMM_WORLD, &rank);
  if(my_rank != rank) {
    sprintf(msg, "NODE %d - 1) ERROR in MPI::Get_rank, rank = %d, should be %d", my_rank, my_rank, rank);
    Fail(msg);
  }

  Pass(); // Get_rank;

  Testing("Get_size");

  MPI_Comm_size(MPI_COMM_WORLD, &size);
  if(comm_size != size) {
    sprintf(msg, "NODE %d - 2) ERROR in MPI::Get_size, rank = %d, should be %d", my_rank, comm_size, size);
    Fail(msg);
  }

  Pass(); // Get_size
}
